package model

import (
	"go.mongodb.org/mongo-driver/bson/primitive"
)

// TODO Tag 這裡在效能與正確性之間做取捨
// 存在貼文內的不提供搜尋，純顯示用，只不過在原始的tag 發生變動的時候，並不會一起改變
// 搜尋會貼文與Tag 的表會再另外一邊做關聯
// 暫時業務邏輯上tag 只提供新增，不提供修改以及刪除，故目前版本可行

type Post struct {
	ID       primitive.ObjectID `bson:"_id,omitempty" json:"id,omitempty"`
	UID      string             `bson:"uid" json:"uid"`
	Content  string             `bson:"content" json:"content"`
	Status   int8               `bson:"status" json:"status"`       // 1. 等待審核中 , 2 審核通過，預設為 1
	IsAd     bool               `bson:"is_ad" json:"is_ad"`         // 此則貼文是否為廣告貼文
	Tags     []string           `bson:"tags" json:"tags"`           // 本則貼文的標籤，不提供搜尋，僅提供顯示(存名字，ID 建立之後就不提供修改與刪除)
	Media    []Media            `bson:"media_url" json:"media_url"` // 網址
	Like     uint64             `bson:"like" json:"like"`           // 讚
	DisLike  uint64             `bson:"dislike" json:"dislike"`     // 不讚
	UpdateAt int64              `bson:"updateAt,omitempty" json:"updateAt,omitempty"`
	CreateAt int64              `bson:"createAt,omitempty" json:"createAt,omitempty"`
}

type Media struct {
	Type  string // media type jpeg, m3u8 之類的
	Links string // 連結的網址
}
